<?php

/*
 * This file is part of the Badger package
 *
 * (c) Olivier Soulet & Anael Chardan
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

declare(strict_types=1);

namespace Badger\Member\Infrastructure\Storage\Doctrine\Mapping\Member;

use Badger\Member\Domain\Member\MemberName;
use Doctrine\DBAL\Platforms\AbstractPlatform;
use Doctrine\DBAL\Types\StringType;

final class MemberNameType extends StringType
{
    public const NAME = 'member_name';

    public function getName(): string
    {
        return MemberNameType::NAME;
    }

    public function convertToPHPValue($value, AbstractPlatform $platform)
    {
        return MemberName::fromString($value);
    }

    public function convertToDatabaseValue($value, AbstractPlatform $platform)
    {
        return $value;
    }
}
